# Create a new Operation Endpoint: POST /v0/operations/ Version: 1.0.0 Security: apiKey ## Request fields (application/json): - `operation_type` (string) Enum: "CONVERGE", "INSTALL", "UNINSTALL", "INSTALL_APP", "UNINSTALL_APP", "REBOOT", "LOCK", "SHUT_DOWN", "WIPE", "ADD_EMM_ACCOUNT", "ADD_OVERRIDE_APN", "ADD_WIFI_AP", "REMOVE_WIFI_AP", "SET_ETHERNET_SETTINGS", "SET_STATIC_IP", "USE_ONLY_SAVED_WIFI_AP", "ADD_TO_WHITELIST", "REMOVE_FROM_WHITELIST", "ALLOW_BLUETOOTH", "ALLOW_CAMERA", "ALLOW_FACTORY_RESET", "ALLOW_UNENROLLMENT_FROM_DEVICE", "DEFER_OS_UPDATES", "PAUSE_OS_UPDATES", "SET_OS_UPDATE_POLICY", "APPLE_APP_UNINSTALL", "APPLY_APP_CONFIG", "CLEAR_APP_DATA", "DIRECT_IOS_APP_INSTALL", "INSTALL_CERTIFICATE", "INSTALL_OTA", "NOTIFY_OTA", "REFRESH_APPLIST", "SET_APP_NOTIFICATIONS", "SET_APP_PERMISSION", "SET_APP_STATE", "SET_KIOSK_APP", "SET_MULTI_APP_MODE", "SET_NEW_POLICY", "SIMPLE_INSTALL", "SYNC_CONTENT", "UNINSTALL_CERTIFICATE", "VPP_APP_INSTALL", "INSTALL_PROFILE", "INSTALL_PROVISIONING_PROFILE", "INSTALL_WEBCLIP", "REMOVE_PROVISIONING_PROFILE", "UNINSTALL_WEBCLIP", "LIST_PROVISIONING_PROFILES", "BEEP_DEVICE", "CAPTURE_SCREENSHOT", "INITIATE_CONFERENCE_CALL", "INITIATE_OFFER", "NOTIFY_DEVICE", "NUDGE_DEVICE", "REQUEST_BUGREPORT", "REQUEST_DPCLOG", "DEPLOY_SYSTEM_OTA", "UPDATE_BLUEPRINT", "UPDATE_DEVICE_CONFIG", "UPDATE_OEM_CONFIG", "CLEAR_PASSCODE", "RESET_LOCKSCREEN_PASSWORD", "SET_ADB_STATE", "SET_DEVICE_LOCKDOWN_STATE", "DISABLE_LOST_MODE", "ENABLE_LOST_MODE", "LOST_MODE_DEVICE_LOCATION", "PLAY_LOST_MODE_SOUND", "SET_BLUETOOTH_STATE", "SET_BRIGHTNESS_SCALE", "SET_DEVICE_LANGUAGE", "SET_GEO_FENCE", "SET_GPS_STATE", "SET_LOCATION_SERVICE", "SET_ROTATION_STATE", "SET_SCREEN_OFF_TIMEOUT", "SET_STREAM_VOLUME", "SET_TIMEZONE", "SET_WALLPAPER", "SET_WIDGET", "SET_WIFI_STATE", "RUN_CSP_PAYLOAD", "SET_PFN", "COLLECT_LOGS", "REMOTE_CONNECTION", "REMOVE_AGENT", "REMOVE_DEVICE", "RUN_CUSTOM_ACTION", "RUN_SHELL_SCRIPT", "DECLARATIVE_MANAGEMENT" - `schedule_type` (string) Following Schedule types are supported ``` * IMMEDIATE: Schedule the command to execcute Immediately * WINDOW: Schedule the command to execute within the given window Enum: "IMMEDIATE", "WINDOW" - `schedule_args` (object) - `schedule_args.start_datetime` (string) Start date and time in ISO 8601 format, including timezone (e.g., 2024-08-08T14:30:00Z or 2024-08-08T14:30:00+05:30). - `schedule_args.end_datetime` (string) End date and time in ISO 8601 format, including timezone (e.g., 2024-08-08T15:30:00Z or 2024-08-08T15:30:00+05:30). - `schedule_args.time_type` (string) The Time-Type argument, in Schedule args, is to indicate which timezone the Command Framework should utilize when scheduling the command. Following Schedule Args for Time-Type are supported: * CONSOLE: Use the local timezone of the user creating the schedule. * DEVICE: Use the local timezone of the device, to which the command is issued, wherever it may be. Enum: "console", "device" - `schedule_args.window_start_time` (string) It is automatically populated by the time field from the request's start_datetime and cannot be injected via the API request body. - `schedule_args.window_end_time` (string) It is automatically populated by the time field from the request's end_datetime and cannot be injected via the API request body. - `schedule_args.days` (array) - `operation_device_query` (object) A flexible JSON object to define device properties and filters. - `arguments` (object) - `arguments.converge_with_provision` (boolean) - `arguments.sample_key` (string) ## Response 201 fields (application/json): - `content` (object) - `content.id` (string) - `content.operation` (string) Enum: "CONVERGE" - `content.state` (string) Enum: "CREATED", "RESOLVING", "RESOLVED", "DISPATCHING", "COMPLETED", "FAILED" - `content.schedule_type` (string) Following Schedule types are supported ``` * IMMEDIATE: Schedule the command to execcute Immediately * WINDOW: Schedule the command to execute within the given window Enum: "IMMEDIATE", "WINDOW" - `content.schedule_args` (object) - `content.schedule_args.start_datetime` (string) Start date and time in ISO 8601 format, including timezone (e.g., 2024-08-08T14:30:00Z or 2024-08-08T14:30:00+05:30). - `content.schedule_args.end_datetime` (string) End date and time in ISO 8601 format, including timezone (e.g., 2024-08-08T15:30:00Z or 2024-08-08T15:30:00+05:30). - `content.schedule_args.time_type` (string) The Time-Type argument, in Schedule args, is to indicate which timezone the Command Framework should utilize when scheduling the command. Following Schedule Args for Time-Type are supported: * CONSOLE: Use the local timezone of the user creating the schedule. * DEVICE: Use the local timezone of the device, to which the command is issued, wherever it may be. Enum: "console", "device" - `content.schedule_args.window_start_time` (string) It is automatically populated by the time field from the request's start_datetime and cannot be injected via the API request body. - `content.schedule_args.window_end_time` (string) It is automatically populated by the time field from the request's end_datetime and cannot be injected via the API request body. - `content.schedule_args.days` (array) - `content.operation_device_query` (object) - `content.arguments` (object) - `content.arguments.converge_with_provision` (boolean) - `content.arguments.sample_key` (string) - `content.reason` (string) - `content.created_at` (string) - `content.created_by` (string) - `content.updated_at` (string) - `content.updated_by` (string) - `content.operation_activity` (array) - `content.operation_activity.operation_state` (string) Enum: "CREATED", "QUERY INITIATED", "QUERY RESOLVED", "DISPATCHING", "DISPATCHED", "PROCESSING", "SUCCESS", "FAILURE" - `content.operation_stats` (object) - `content.operation_stats.device_operation_statuses_count` (object) - `content.operation_stats.device_operation_statuses_count.resolved_device_count` (integer) - `content.operation_stats.device_operation_statuses_count.dispatched_device_count` (integer) - `content.operation_stats.device_operation_statuses_count.dispatch_failed_count` (integer) - `content.operation_stats.device_operation_statuses_count.failed_device_count` (integer) - `content.operation_stats.device_operation_statuses_count.success_device_count` (integer)